local famBags = LibStub('AceAddon-3.0'):NewAddon('famBags', 'AceEvent-3.0', 'AceConsole-3.0', 'AceHook-3.0')
local L = LibStub('AceLocale-3.0'):GetLocale('famBags')
local LSM = LibStub('LibSharedMedia-3.0')
local lbf = LibStub("LibButtonFacade", true)
famBags.L = L
famBags.SortedCategories = {}
famBags.BagIndexes = {}
famBags.Inventory = {}
famBags.CHANGING_PROFILE = nil
famBags.BAGS_NEED_LAYOUT = nil
famBags.BANK_NEED_LAYOUT = nil
famBags.EMPTIES_NEED_LAYOUT = {
   bags = true,
   bank = true,
}
famBags.BagTypes = {
   [0] = 'any',
   [1] = 'quiver',
   [2] = 'ammo',
   [4] = 'soul',
   [8] = 'leather',
   [16] = 'inscription',
   [32] = 'herbs',
   [64] = 'enchanting',
   [128] = 'engineering',
   [256] = 'key',
   [512] = 'gem',
   [1024] = 'mining',
}
famBags.OPTIMIZATION = {
   inProgress = false,
   index = 0,
   subIndex = 0,
   bag = '',
   set = {}
}

-- timer for OnUpdate execution control
famBags.timerFrame = CreateFrame('Frame', 'famBagsTimerFrame', UIParent)
famBags.timerFrame:Hide()
famBags.timer = 0
famBags.ticktime = 1
famBags.timerFrame:SetScript("OnUpdate",function(self, elapsed)
   famBags.timer = famBags.timer + elapsed
   if famBags.timer >= famBags.ticktime then
      famBags:TimerTick()
      famBags.timer = 0
   end
end)

-- :::::::::::: famBags.Categories ::::::::::::: -------------------------------------------------------------------------

famBags.Types = {
   [L['Armor']] = { L['Miscellaneous'], L['Cloth'], L['Leather'], L['Mail'], L['Plate'], L['Shields'], L['Librams'], L['Idols'], L['Totems'], L['Sigils'] },
   [L['Consumable']] = { L['Food & Drink'], L['Potion'], L['Elixir'], L['Flask'], L['Bandage'], L['Item Enhancement'], L['Scroll'], L['Other'], L['Consumable'] },
   [L['Container']] = { L['Bag'], L['Enchanting Bag'], L['Engineering Bag'], L['Gem Bag'], L['Herb Bag'], L['Mining Bag'], L['Soul Bag'], L['Leatherworking Bag'] },
   [L['Gem']] = { L['Blue'], L['Green'], L['Orange'], L['Meta'], L['Prismatic'], L['Purple'], L['Red'], L['Simple'], L['Yellow'] },
   [L['Miscellaneous']] = { L['Junk'], L['Reagent'], L['Pet'], L['Holiday'], L['Mount'], L['Other'] },
   [L['Money']] = {},
   [L['Reagent']] = {},
   [L['Recipe']] = { L['Alchemy'], L['Blacksmithing'], L['Book'], L['Cooking'], L['Enchanting'], L['Engineering'], L['First Aid'], L['Leatherworking'], L['Tailoring'] },
   [L['Quest']] = {},
   [L['Trade Goods']] = { L['Armor Enchantment'], L['Cloth'], L['Devices'], L['Elemental'], L['Enchanting'], L['Explosives'], L['Herb'], L['Jewelcrafting'], L['Leather'],
                        L['Materials'], L['Meat'], L['Metal & Stone'], L['Other'], L['Parts'], L['Trade Goods'], L['Weapon Enchantment'] },
   [L['Weapon']] = { L['Bows'], L['Crossbows'], L['Daggers'], L['Guns'], L['Fishing Poles'], L['Fist Weapons'], L['Miscellaneous'], L['One-Handed Axes'], L['One-Handed Maces'],
                   L['One-Handed Swords'], L['Polearms'], L['Staves'], L['Thrown'], L['Two-Handed Axes'], L['Two-Handed Maces'], L['Two-Handed Swords'], L['Wands'] },
}

famBags.Criterias = {
   [L['Quality']] = { options = {L['unknown'], '0.'..ITEM_QUALITY0_DESC, '1.'..ITEM_QUALITY1_DESC, '2.'..ITEM_QUALITY2_DESC, '3.'..ITEM_QUALITY3_DESC, '4.'..ITEM_QUALITY4_DESC, '5.'..ITEM_QUALITY5_DESC,
                     '6.'..ITEM_QUALITY6_DESC, '7.'..ITEM_QUALITY7_DESC, } },
   [L['Equipment Slot']] = { options = {INVTYPE_AMMO, INVTYPE_HEAD, INVTYPE_NECK, INVTYPE_SHOULDER, INVTYPE_BODY, INVTYPE_CHEST, INVTYPE_ROBE, INVTYPE_WAIST, INVTYPE_LEGS, INVTYPE_FEET,
                            INVTYPE_WRIST, INVTYPE_HAND, INVTYPE_FINGER, INVTYPE_TRINKET, INVTYPE_CLOAK, INVTYPE_WEAPON, INVTYPE_SHIELD, INVTYPE_2HWEAPON,
                            INVTYPE_WEAPONMAINHAND, INVTYPE_WEAPONOFFHAND, INVTYPE_HOLDABLE, INVTYPE_RANGED, INVTYPE_THROWN, INVTYPE_RANGEDRIGHT, INVTYPE_RELIC, INVTYPE_TABARD }, },
   [L['Bound Status']] = { options = {L['Binds when picked up'], L['Binds when equipped'], L['Soulbound'], L['Binds to account'], L['Account Bound']}, },
   [L['Equipment Set']] = { options = {}, },
   [L['Outfitter Set']] = { options = {}, },
   [L['Quest']] = { options = {}, },
   [L['Key']] = { options = {}, },
   [L['Empty']] = { options = {}, },
   [L['Usable']] = { options = {}, },
   [L['New']] = { options = {}, },
   [L['Incremented']] = { options = {}, },
   [L['Others']] = { options = {}, },
   [L['Name']] = { options = {L['Equal'], L['Contains'], L['Starts with'], L['Ends with']}, valueType = 'text', },
   [L['Item Level']] = { options = {L['Equal'], L['Greater or equal'], L['Less or equal']}, valueType = 'text', },
   [L['Required Level']] = { options = {L['Equal'], L['Greater or equal'], L['Less or equal']}, valueType = 'text', },
}

-- :::::::::::: DB ::::::::::::: -------------------------------------------------------------------------

local db

function famBags:GetBGDefaults()
   return {
      type = 1, -- Solid
      color1 = {0,0,0,0.7},
      color2 = {0,0,0,0.7},
      texture = nil,
      inset = 0,
      br_texture = 'None',
      br_color = {1,1,1,1},
      br_size = 10,
   }
end

function famBags:GetTextDefaults()
   return {
      font = '',
      size = 11,
         flags = {
         ['OUTLINE'] = false,
         ['THICKOUTLINE'] = false,
         ['MONOCHROME'] = false,
         ['SHADOW'] = true,
      },
      color = {1,1,1},
      halign = 'LEFT',
      valign = 'CENTER',
      padding = 1,
   }
end

function famBags:GetTitleDefaults()
   return {
      is_inset = false,
      inset = 0,
      bg = self:GetBGDefaults(),
      text = self:GetTextDefaults()
   }
end

local defaults = {
   profile =  {
      stackmode = true,
      layout = {
         skins = {
            bags = {},
         },
         general ={
            strata = 'HIGH',
            sections = 'categories',
            ordered = true,
            show_keys = true,
            full_layout = false,
            update_time = 0.7,
         },
         sections = {
            compact = true,
            hpadding = 5,
            vpadding = 5,
            hspacing = 5,
            vspacing = 5,
         },
         buttons = {
            hpadding = 5,
            vpadding = 5,
            hspacing = 5,
            vspacing = 5,
            size = 0.7,
            quality_glow = 'round1',
            quality_glow_alpha = 1,
            quality_glow_inset = 0,
            indicators_enabled = true,
            indicators_size = 1,
            indicators_offset = 2,
         },
         stacks = {
            only_stackable = false,
            only_full = false,
         },
         counts = famBags:GetTextDefaults(),
         empties = {
            bg = famBags:GetBGDefaults(),
            hpadding = 5,
            vpadding = 5,
            vpos = 'TOP',
            hpos = 'RIGHT',
            no_empty_text = 'x',
            no_empty_color = {1,0,0},
         },
      },
      mainwindow = {
         layout = {
            buttons_x_row = 10,
            halign = 'RIGHT',
            valign = 'TOP',
            hspacing = 40,
            vspacing = 40,
            persist_pos = true,
            fixed_width = true,
         },
         bg = famBags:GetBGDefaults(),
         title = famBags:GetTitleDefaults()
      },
      money = {
         enabled = true,
         show_silver = true,
         show_copper = true,
         bg = famBags:GetBGDefaults(),
         text = famBags:GetTextDefaults(),
      },
      bank = {
         layout = {
            buttons_x_row = 15,
            halign = 'LEFT',
            valign = 'TOP',
            hspacing = 40,
            vspacing = 40,
            persist_pos = true,
            fixed_width = true,
         },
         bg = famBags:GetBGDefaults(),
         title = famBags:GetTitleDefaults()
      },
      bankwindow = {
         enabled = true,
         bg = famBags:GetBGDefaults(),
      },
      bagswindow = {
         enabled = true,
         bg = famBags:GetBGDefaults(),
      },
      sections = {
         bags= {
            bg = famBags:GetBGDefaults(),
            title = famBags:GetTitleDefaults(),
         },
      },
      categories = {
      },
   },
}

-- :::::::::::: LOCALS ::::::::::::: -------------------------------------------------------------------------

local function npairs(t)
	local a = {}
		for n in pairs(t) do table.insert(a, n) end
		table.sort(a)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if a[i] == nil then return nil
			else return a[i], t[a[i]]
			end
		end
	return iter
end

local LOADING = true
local UPDATE_COOLDOWNS = false
local BAGS_CHANGED = {}
local BAGS_CHANGED_COUNT = 0
-- :::::::::::: famBags ::::::::::::: -------------------------------------------------------------------------

function famBags:BuildSortedCategories()
   self.SortedCategories = {}
   for n in npairs(db.categories) do
      table.insert(self.SortedCategories, n)
   end
end

function famBags:BuildBagIndexes()
   self.BagIndexes = {
      bags = {},
      bank = {}
   }
   for i = 0, NUM_BAG_SLOTS do
      table.insert(self.BagIndexes.bags, i)
   end
   if db.layout.general.show_keys then
      table.insert(self.BagIndexes.bags, KEYRING_CONTAINER)
   end
   table.insert(self.BagIndexes.bank, BANK_CONTAINER)
   for i = NUM_BAG_SLOTS + 1, NUM_BAG_SLOTS + NUM_BANKBAGSLOTS do
      table.insert(self.BagIndexes.bank, i)
   end
end

function famBags:BuildInventory()
   wipe(self.Inventory)
   local id, count
   for _, bag in ipairs(self.BagIndexes.bags) do
      local slots = GetContainerNumSlots(bag)
      if slots then
         for slot = 1, slots do
            id = GetContainerItemID(bag, slot)
            if id then
               _, count = GetContainerItemInfo(bag, slot)
               if self.Inventory[id] then
                  self.Inventory[id] = self.Inventory[id] + (count or 0)
               else
                  self.Inventory[id] = count
               end
            end
         end
      end
   end
end

function famBags:GetInventoryForItem(itemID)
   if not itemID then return 0 end
   local id, count, b
   local total = 0
   for _, bag in ipairs(self.BagIndexes.bags) do
      local slots = GetContainerNumSlots(bag)
      if slots then
         for slot = 1, slots do
            id = GetContainerItemID(bag, slot)
            b = nil
            if id == itemID then
               if self.Buttons[bag] then
                  b = self.Buttons[bag][slot]
                  if b then
                     if b.info.new then
                        return 'new'
                     elseif b.info.added then
                        return 'added'
                     end
                  end
               end
               _, count = GetContainerItemInfo(bag, slot)
               total = total + (count or 0)
            end
         end
      end
   end
   return total
end

function famBags:GetDBDefaults()
   return defaults
end

function famBags:OnInitialize(...)
   self.db = LibStub('AceDB-3.0'):New('famBags', defaults, 'Default')
   db = self.db.profile
   self:InitLayoutVars()
   self.isStackMode = db.stackmode
   self.MoveToCategoryDD = CreateFrame("Frame", "famBagsMoveToCategoryDD", UIParent, "UIDropDownMenuTemplate");
   UIDropDownMenu_Initialize(self.MoveToCategoryDD, self.InitMoveToCategoryMenu, "MENU");
   self:RegisterChatCommand('fam', 'ChatCommand')
   self:RegisterChatCommand('fambags', 'ChatCommand')
   self:RawHook("OpenAllBags", "ToggleBags", true)
   self:RawHook("OpenBackpack", "ShowBags", true)
   --self:RawHook("CloseBackpack", "HideBags", true)
   self:RawHook("CloseSpecialWindows", "HideBagsOnEsc", true)
   self:RawHook("ContainerFrameItemButton_OnEnter", "ContainerFrameItemButtonOnEnter", true)
   self:RawHook("ContainerFrameItemButton_OnModifiedClick", "ContainerFrameItemButtonOnModifiedClick", true)
   self:RawHook("SetCurrencyBackpack", "SetCurrencyBackpack", true)
   self:RawHookScript(BankFrame, "OnEvent", "BankFrameOnEvent")
end

function famBags:OnEnable()
   self:RegisterEvent('PLAYER_ENTERING_WORLD')
   self:RegisterEvent('ITEM_LOCK_CHANGED')
   self:RegisterEvent('BAG_UPDATE_COOLDOWN')
   self:RegisterEvent('EQUIPMENT_SETS_CHANGED')
   self:RegisterEvent("BANKFRAME_OPENED")
   self:RegisterEvent("BANKFRAME_CLOSED")
   self:RegisterEvent("PLAYER_MONEY")
   self:RegisterEvent('AUCTION_HOUSE_SHOW')
   self:RegisterEvent('AUCTION_HOUSE_CLOSED')
   self:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
   self:RegisterEvent("KNOWN_CURRENCY_TYPES_UPDATE");
end

function famBags:ChatCommand(input)
   if not input or input:trim() == '' then
      self:LoadOptions()
   end
end

function famBags:LoadOptions()
   if LoadAddOn('famBagsOptions') then
      InterfaceOptionsFrame_OpenToCategory('famBags')
   end
end

function famBags:FullRefresh()
   local function wipe_section(sections, wipeit)
      if not sections then return end
      for _, s in pairs(sections) do
         s:Hide()
      end
      if wipeit then
         wipe(sections)
      end
   end

   CloseBankFrame()
   CloseBackpack()
   db = self.db.profile
   for _, indexes in pairs(self.BagIndexes) do
      for _, i in ipairs(indexes) do
         if self.Buttons[i] then
            for _, b in ipairs(self.Buttons[i]) do
               b:Hide()
            end
         end
      end
   end
   wipe(self.Buttons.Current)
   if self.Sections.bags then
      wipe_section(self.Sections.bags.bags)
      wipe_section(self.Sections.bags.categories, true)
   end
   if self.Sections.bank then
      wipe_section(self.Sections.bank.bags)
      wipe_section(self.Sections.bank.categories, true)
   end
   self.famBagsMoneyFrame = nil
   self.famBagsBlizzardBankFrame = nil
   self.famBagsBagSlotsFrame = nil
   self.CHANGING_PROFILE = true
   self.EMPTIES_NEED_LAYOUT['bags'] = true
   self.EMPTIES_NEED_LAYOUT['bank'] = true
   LOADING = true
   self:PLAYER_ENTERING_WORLD()
end

function famBags:BankFrameOnEvent(frame, event)
	if (not db.bankwindow.enabled) or (event ~= 'BANKFRAME_OPENED' and event ~= 'BANKFRAME_CLOSED') then
      self.hooks[BankFrame].OnEvent(frame, event)
	end
end

function famBags:ContainerFrameItemButtonOnEnter(b)
	-- Bank main container specific code
	if b:GetParent():GetID() == BANK_CONTAINER then
   	local x = b:GetRight()
   	GameTooltip:SetOwner(b, (x >= ( GetScreenWidth() / 2)) and "ANCHOR_LEFT" or "ANCHOR_RIGHT")
		GameTooltip:SetInventoryItem("player", BankButtonIDToInvSlotID(b:GetID()))
		CursorUpdate(b)
	else
      self.hooks.ContainerFrameItemButton_OnEnter(b)
	end
end

function famBags:ContainerFrameItemButtonOnModifiedClick(b, mousebutton)
	if IsControlKeyDown() and mousebutton == 'RightButton' and b.info and b.info.id then
	   self.MoveToCategoryDD.button = b
	   ToggleDropDownMenu(1, nil, self.MoveToCategoryDD, b:GetName(), b:GetWidth()/2, b:GetHeight()/2)
	else
      self.hooks.ContainerFrameItemButton_OnModifiedClick(b, mousebutton)
	end
end

function famBags:SaveSkin(index, skinID, gloss, backdrop, colors)
   db.layout.skins[index].skinID = skinID
   db.layout.skins[index].gloss = gloss
   db.layout.skins[index].backdrop = backdrop
   db.layout.skins[index].colors = colors
end

function famBags:BFSkinCallback(skinID, gloss, backdrop, group, button, colors)
	if not group then
	   self:SaveSkin('bags', skinID, gloss, backdrop, colors)
	elseif group == 'Bags' then
	   self:SaveSkin('bags', skinID, gloss, backdrop, colors)
	end
	--hack to fix texture size for keyring button
   if self.famBagsBagSlotsFrame and self.famBagsBagSlotsFrame.KeyRingTexture then
      self.famBagsBagSlotsFrame.KeyRingTexture:SetTexCoord(0, 0.5625, 0, 0.609375)
   end
end

function famBags:PLAYER_ENTERING_WORLD()
   if not LOADING then return end
   LOADING = nil
   if not self.CHANGING_PROFILE then
      self:BuildBagIndexes()
      self:EQUIPMENT_SETS_CHANGED()
      self.LDBBags:Create()
      self.LDBCurrency:Create()
   end
   if lbf then
      self.BFBags = lbf:Group("famBags", "Bags")
      self.BFBags:Skin(db.layout.skins.bags.skinID, db.layout.skins.bags.gloss, db.layout.skins.bags.backdrop, db.layout.skins.bags.colors)
      lbf:RegisterSkinCallback("famBags", self.BFSkinCallback, self)
   end
   self:BuildSortedCategories()
   self:UpdateBags()
   self:CreateIntefaceButtons()
   if db.bagswindow.enabled then
      self.BagSlotsButton:SetChecked(false)
   end
   if not self.CHANGING_PROFILE then
      self:RegisterEvent('BAG_UPDATE')
      self:RegisterEvent('PLAYERBANKSLOTS_CHANGED')
      self:RegisterEvent('PLAYERBANKBAGSLOTS_CHANGED')
      if Outfitter then
         if Outfitter:IsInitialized() then
            self.OUTFITTER = true
            Outfitter:RegisterOutfitEvent('EDIT_OUTFIT', self.OUTFITTER_SETS_CHANGED)
            Outfitter:RegisterOutfitEvent('ADD_OUTFIT', self.OUTFITTER_SETS_CHANGED)
            Outfitter:RegisterOutfitEvent('DELETE_OUTFIT', self.OUTFITTER_SETS_CHANGED)
            self:OUTFITTER_SETS_CHANGED()
         else
            Outfitter:RegisterOutfitEvent('OUTFITTER_INIT', self.OUTFITTER_INIT)
         end
      end
   end
end

function famBags:ITEM_LOCK_CHANGED(e, bag, slot)
   if slot and self.Buttons[bag] and not (bag == BANK_CONTAINER and slot > NUM_BANKGENERIC_SLOTS) then
      local b = self.Buttons[bag][slot]
      self.Buttons:UpdateItemLock(b, bag, slot)
      self.Buttons:UpdateLock(b)
   end
end

function famBags:BAG_UPDATE_COOLDOWN(e, bag)
   UPDATE_COOLDOWNS = true
   self.ticktime = 0.1
   self:StartTimer()
end

function famBags:PLAYERBANKSLOTS_CHANGED(e, slot)
   if slot <= NUM_BANKGENERIC_SLOTS then
      self:BAG_UPDATE(e, BANK_CONTAINER)
   else
      self:BAG_UPDATE(e, NUM_BAG_SLOTS + slot - NUM_BANKGENERIC_SLOTS)
      if db.bankwindow.enabled then
		   BankFrameItemButton_Update(self.famBagsBlizzardBankFrame.BankBags[slot - NUM_BANKGENERIC_SLOTS])
		end
   end
end

function famBags:PLAYERBANKBAGSLOTS_CHANGED()
   if db.bankwindow.enabled then
	   UpdateBagSlotStatus()
	end
   local _, full = GetNumBankSlots()
   local f = self.famBagsBlizzardBankFrame
   if full and db.bankwindow.enabled and f and f.PurchaseInfo then
      f.PurchaseInfo:ClearAllPoints()
      f.PurchaseInfo:Hide()
      f:SetHeight(f.BankBags[1]:GetHeight() + 20)
   end
end

function famBags:BAG_UPDATE(e, bag, ...)
   if bag == KEYRING_CONTAINER and not db.layout.general.show_keys then return end
   local found
   for i=1, BAGS_CHANGED_COUNT do
      if BAGS_CHANGED[i] == bag then
         found = true
         break
      end
   end
   if not (found) then
      BAGS_CHANGED_COUNT = BAGS_CHANGED_COUNT + 1
      BAGS_CHANGED[BAGS_CHANGED_COUNT] = bag
   end
   if not self.OPTIMIZATION.inProgress then
      self.ticktime = db.layout.general.update_time
      self:StartTimer()
   end
end

function famBags:EQUIPMENT_SETS_CHANGED()
   if self.EquipmentSets then
      wipe(self.EquipmentSets)
   else
      self.EquipmentSets = {}
   end
   wipe(self.Criterias[L['Equipment Set']].options)
   local setscount = GetNumEquipmentSets()
   for i=1, setscount do
      local set = GetEquipmentSetInfo(i);
      local items = GetEquipmentSetItemIDs(set);
      self.EquipmentSets[set] = {}
      table.insert(self.Criterias[L['Equipment Set']].options, set)
      for _, id in pairs(items) do
         self.EquipmentSets[set][id] = true
      end
   end
   if self.famBagsFrame then
      if IsAddOnLoaded('famBagsOptions') then
         LibStub('AceConfigRegistry-3.0'):NotifyChange('famBags Categories')
      end
      self:LayoutBagsButtons()
   end
end

function famBags:OUTFITTER_INIT()
   if Outfitter:IsInitialized() then
      famBags.OUTFITTER = true
      Outfitter:RegisterOutfitEvent('EDIT_OUTFIT', famBags.OUTFITTER_SETS_CHANGED)
      Outfitter:RegisterOutfitEvent('ADD_OUTFIT', famBags.OUTFITTER_SETS_CHANGED)
      Outfitter:RegisterOutfitEvent('DELETE_OUTFIT', famBags.OUTFITTER_SETS_CHANGED)
      famBags:OUTFITTER_SETS_CHANGED()
   end
end

function famBags:OUTFITTER_SETS_CHANGED()
   if self.OutfitterSets then
      wipe(famBags.OutfitterSets)
   else
      famBags.OutfitterSets = {}
   end
   wipe(famBags.Criterias[L['Outfitter Set']].options)

   for _, c in ipairs(Outfitter:GetCategoryOrder()) do
      for _, o in ipairs(Outfitter:GetOutfitsByCategoryID(c)) do
         if not o:IsEmpty() then
            local set = o:GetName()
            famBags.OutfitterSets[set] = {}
            table.insert(famBags.Criterias[L['Outfitter Set']].options, set)
            for _, info in pairs(o.Items) do
               famBags.OutfitterSets[set][info.Code] = true
            end
         end
      end
   end
   --dump('famBags.OutfitterSets',famBags.OutfitterSets)
   if famBags.famBagsFrame then
      if IsAddOnLoaded('famBagsOptions') then
         LibStub('AceConfigRegistry-3.0'):NotifyChange('famBags Categories')
      end
      if famBags.BAGS_LOADED then
         famBags:LayoutBagsButtons()
      end
   end
end

function famBags:BANKFRAME_OPENED()
   self.famBankFrame:Show()
   if db.bankwindow.enabled then
   	for i=1, NUM_BANKBAGSLOTS, 1 do
   		button = _G["BankFrameBag"..i];
   		BankFrameItemButton_Update(button);
   	end
   	UpdateBagSlotStatus();
   end
   self:LayoutBagsButtons('bank')
   self:ShowBags()
end

function famBags:BANKFRAME_CLOSED()
   if self.famBankFrame and self.famBankFrame:IsVisible() then
      self.famBankFrame:Hide()
      self:HideBags()
   end
end

function famBags:AUCTION_HOUSE_SHOW()
   self:ShowBags()
end

function famBags:AUCTION_HOUSE_CLOSED()
   self:HideBags()
end

function famBags:PLAYER_MONEY()
   self:UpdateCurrency()
end

function famBags:SetCurrencyBackpack(...)
   self.hooks.SetCurrencyBackpack(...)
   self:UpdateCurrency()
end

function famBags:CURRENCY_DISPLAY_UPDATE()
   self:UpdateCurrency()
end

function famBags:KNOWN_CURRENCY_TYPES_UPDATE()
   self:UpdateCurrency()
end

function famBags:UpdateCurrency()
   local money = self:GetMoney()
   if self.famBagsMoneyFrame then
      self:SetTextLayout(self.famBagsMoneyFrame, 'moneyText', db.money.text, money, true, false)
   end
   self.LDBCurrency:Update(money)
end

function famBags:StartTimer()
   self.timer = 0
   self.timerFrame:Show()
end

function famBags:StopTimer()
   self.timerFrame:Hide()
end

function famBags:TimerTick()
   if self.OPTIMIZATION.inProgress then
      self:StopTimer()
      self:OptimizeStacks(self.OPTIMIZATION.bag)
      return
   end
   if UPDATE_COOLDOWNS then
      self.Buttons:UpdateButtonsCooldown()
      UPDATE_COOLDOWNS = false
   end
   if BAGS_CHANGED_COUNT > 0 then
      self:UpdateChangedBags()
   end
   if not(UPDATE_COOLDOWNS or #BAGS_CHANGED > 0) then
      self:StopTimer()
   end
end

function famBags:ShowBags()
   if not self.famBagsFrame:IsVisible() then
      self.famBagsFrame:Show()
      self:LayoutBagsButtons('bags')
      PlaySound("igBackPackOpen")
   end
end

function famBags:HideBagsOnEsc()
   if self.famBagsFrame and self.famBagsFrame:IsVisible() then
      self:HideBags()
      CloseBankFrame()
      return self.hooks.CloseSpecialWindows() or 1
   end
   CloseBankFrame()
   return self.hooks.CloseSpecialWindows()
end

function famBags:HideBags()
   if self.famBagsFrame and self.famBagsFrame:IsVisible() then
      self.famBagsFrame:Hide()
      PlaySound("igBackPackClose")
   end
end

function famBags:ToggleBags(force)
   if (not self.famBagsFrame:IsVisible()) or force then
      self.famBagsFrame:Show()
      self:LayoutBagsButtons('bags')
      PlaySound("igBackPackOpen")
   else
      self:HideBags()
   end
end

function famBags:UpdateChangedBags()
   self.LDBBags:Update()
   if FIRST_BUILD or not self.famBagsFrame then
      self:BuildInventory()
      BAGS_CHANGED_COUNT = 0
      FIRST_BUILD = nil
      return
   end
   local i
   local updatebags
   local updatebank
   local bagchanged
   self.BAGS_NEED_LAYOUT = nil
   self.BANK_NEED_LAYOUT = nil
   for k = 1, BAGS_CHANGED_COUNT do
      i = BAGS_CHANGED[k]
      bagchanged = nil
      local slots = GetContainerNumSlots(i)
      local bagType = select(2, GetContainerNumFreeSlots(i))
      if self.Buttons and self.Buttons[i] then
         if i ~= KEYRING_CONTAINER and bagType ~= self.Buttons[i].bagType then
            bagchanged = (tContains(self.BagIndexes.bags, i)) and 'bags' or 'bank'
            self.Buttons[i].bagType = bagType
            self.EMPTIES_NEED_LAYOUT[bagchanged] = true
         end
         if #self.Buttons[i] > slots then
            for j = slots + 1, #self.Buttons[i] do
               self.Buttons[i][j]:Hide()
            end
         end
      end
      self:UpdateBagButtons(i, slots, bagchanged)
      if tContains(self.BagIndexes.bags, i) then
         updatebags = true
      elseif tContains(self.BagIndexes.bank, i) then
         updatebank = true
      end
   end
   BAGS_CHANGED_COUNT = 0
   if updatebags then
      if db.layout.general.full_layout or self.BAGS_NEED_LAYOUT then
         self:LayoutBagsButtons('bags')
         self:BuildInventory()
      else
         self:LightLayoutBagsButtons('bags')
      end
   end
   if updatebank then
      if db.layout.general.full_layout or self.BANK_NEED_LAYOUT then
         self:LayoutBagsButtons('bank')
      else
         self:LightLayoutBagsButtons('bank')
      end
   end
end

function famBags:MoveToCategory(category, id)
   if id then
      local c = db.categories
      for _, cat in pairs(self.SortedCategories) do
         if c[cat].Items and c[cat].Items[id] then
            c[cat].Items[id] = nil
            break
         end
      end
      if category ~= 'clear' then
         c[category].Items = c[category].Items or {}
         c[category].Items[id] = 1
      end
      self:LayoutBagsButtons()
   end
end

function famBags:UseSectionItems()
--   print('****',self.SellingSectionBag,self.SellingSectionType,self.SellingSection)
   if not (self.SellingSection and self.SellingSectionBag and
           self.Buttons.Current[self.SellingSectionBag] and
           self.Buttons.Current[self.SellingSectionBag][self.SellingSection]) then
      return
   end
--   for n in pairs(self.Buttons.Current[self.SellingSectionBag]) do
--      print(n)
--   end
   for _,b in ipairs(self.Buttons.Current[self.SellingSectionBag][self.SellingSection]) do
      if b.info.id then
         for _,b1 in ipairs(b.stacks) do
            if b1.info.id then
               ContainerFrameItemButton_OnClick(b1, 'RightButton')
            end
         end
         ContainerFrameItemButton_OnClick(b, 'RightButton')
      end
   end
end

--[[
function famBags:OnDisable()
end

SLASH_FAMBAGS1 = '/fambags'
SlashCmdList['FAMBAGS'] = function(msg, editbox)
end
--]]
